
require "digest"
require "daphne_util/version"
require "daphne_util/id_generator"
require "daphne_util/secret_generator"
require "daphne_util/api_key_generator"
require "daphne_util/errors"
require "daphne_util/tools"


module DaphneUtil

  def self.salt
    @salt ||= "Fuego! Fuego! Fuego!"
    raise DaphneUtil::SaltUndefined unless @salt
    Digest::SHA512.hexdigest(@salt.to_s)
  end

  def self.apps
    ['seanet', 'poseidon', 'apollo', 'ics']
  end

  def self.prefix(val)
    apps.include?(val.to_s.strip.downcase) ? val : "application"
  end

  def self.salt=(val)
    @salt = val
  end

  def self.generate_id(*seed)
    DaphneUtil::IdGenerator.generate(*seed)
  end

  def self.generate_secret(*seed)
    DaphneUtil::SecretGenerator.generate(*seed)
  end

  def self.generate_api_key(*seed)
    DaphneUtil::ApiKeyGenerator.generate(*seed)
  end

  def generate_id(*seed)
    DaphneUtil::IdGenerator.generate(*seed)
  end

  def generate_secret(*seed)
    DaphneUtil::SecretGenerator.generate(*seed)
  end

  def generate_api_key(*seed)
    DaphneUtil::ApiKeyGenerator.generate(*seed)
  end

end
